-- status = in progress
-- version = 24jan01

-- OR switch to dbGnlPpsEvntCsmr and delete individual tables
-- use dbGnlPpsEvntCsmr
-- go

-- drop tblUrls
-- if exists (select * from sysobjects where id = object_id(N'[dbo].[tblUrls]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
-- drop table [dbo].[tblUrls]
-- go

-- drop tblEvents
-- if exists (select * from sysobjects where id = object_id(N'[dbo].[tblEvents]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
-- drop table [dbo].[tblEvents]
-- go

-- OR switch to master database and delete entire dbGnlPpsEvntCsmr database
use master
go

-- drop dbGnlPpsEvntCsmr
if exists (select * from sysdatabases where name = N'dbGnlPpsEvntCsmr')
drop database dbGnlPpsEvntCsmr
go

-- create dbGnlPpsEvntCsmr
create database dbGnlPpsEvntCsmr
go

-- switch to dbGnlPpsEvntCsmr database
use dbGnlPpsEvntCsmr
go

-- create tblEvntLog
create table [dbo].[tblEvents] (
	[idEvent] [int] identity(1, 1) not null ,
	[vcHostname] [varchar] (100) not null ,
	[vcIpAddress] [varchar] (16) not null ,
	[vcAgent] [varchar] (25) not null ,
	[vcName] [varchar] (25) not null ,
	[vcDescription] [varchar] (100) not null ,
	[dtCreate] [datetime] not null ,
	[dtTerminate] [datetime] null ,
	[iDuration] [int] null ,
	[vcUser] [varchar] (50) null ,
-- example(s)
-- administrator@myDomain.com = 27 chars 
	[vcOtherPropA] [varchar] (50) null ,
-- example(s)
-- 53218 = 5 chars
	[vcOtherPropB] [varchar] (50) null ,
-- example(s)
-- notepad.exe = 11 chars
	[vcOtherPropC] [varchar] (75) null ,
-- example(s)
-- c:\program Files\microsoft office\office\winword.exe = 52 chars
-- c:\program Files\microsoft office\office\powerpnt.exe = 53 chars
-- d:\mydistfld\office2k\pfiles\msoffice\office\msaccess.exe = 57 chars
	[vcOtherPropD] [varchar] (50) null ,
	[vcOtherPropE] [varchar] (50) null ,
	[vcOtherPropF] [varchar] (50) null
) on [primary]
go

-- create tblUrls
create table [dbo].[tblUrls] (
	[iUrlId] [int] identity (1, 1) not null ,
	[vcLabel] [varchar] (128) not null ,
	[vcUrl] [varchar] (256) not null 
) on [primary]
go

-- insert some sample prcCreateEvent and prcTerminateEvent data into tblEvents
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC)
	values ('MYDEVB', '4.33.175.45', 'gpec24jan01', 'lgcGpecPrcCreateEvent', 'prcCreateEvent', '2000-09-22 08:26:09.471', 'johnd@mydistdom', '59884', 'IEXPLORE.EXE', 'C:\Program Files\Internet Explorer\IEXPLORE.EXE')
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC)
	values ('MYDEVA', '4.33.181.83', 'gpec24jan01', 'lgcGpecPrcTerminateEvent', 'prcTerminateEvent', '2000-09-22 08:25:12.123', '2000-09-22 08:30:32.413', '320','eddiem@mydistdom', '58112', 'notepad.exe', 'C:\OS\System32\notepad.exe')
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC)
	values ('MYDEVB', '4.33.175.45', 'gpec24jan01', 'lgcGpecPrcCreateEvent', 'prcCreateEvent', '2000-09-22 08:26:09.471', '', '','coryh@mydistdom', '59884', 'IEXPLORE.EXE', 'C:\Program Files\Internet Explorer\IEXPLORE.EXE')
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC)
	values ('MYDEVA', '4.33.181.83', 'gpec24jan01', 'lgcGpecPrcCreateEvent', 'prcCreateEvent', '2000-09-22 08:26:09.471', '', '','rickyc@mydistdom', '72504', 'WINWORD.EXE', 'C:\PROGRA~1\MI1933~1\Office\WINWORD.EXE')
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC)
	values ('MYDEVB', '4.33.175.45', 'gpec24jan01', 'lgcGpecPrcTerminateEvent', 'prcTerminateEvent', '2000-09-22 09:42:38.660', '2000-09-22 10:40:10.912', '3459','travisp@mydistdom', '72504', 'mmc.exe', 'C:\OS\System32\mmc.exe')
-- test terminate update event simulation when multiple records exist with the same vcOtherPropC == ProcessID value
-- this should update the mydeva create event for winword.exe and not the mydevb mmc.exe event with the same processid 
update tblEvents set vcName = 'lgcGpecPrcTerminateEvent', vcDescription = 'prcTerminateEvent',
		     dtTerminate = '2000-09-22 08:36:34.213', iDuration = '625'
--	where  vcOtherPropA = '72504' and vcHostname = 'MYDEVA' and vcIpAddress = '4.33.181.83' and vcName = 'prcCreateEvent and dtTerminate = '1900-01-01' and iDuration = '0' and vcOtherPropB = 'WINWORD.EXE'
	where  vcOtherPropA = '72504' and vcHostname = 'MYDEVA' and iDuration = '0' and vcOtherPropB = 'WINWORD.EXE'

-- insert some sample prcCreateEvent and prcTerminateEvent data into tblEvents
/*
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC, vcOtherPropD, vcOtherPropE, vcOtherPropF)
	values ('MYDEVA', '4.33.181.83', 'wmi', 'lgcGpecLogEvent', 'logEvent', '2000-06-09 04:25:00.000', '', '', '', 'Application', 'TlntSvr', 'information', '0', '1000', 'The MS Telnet Service has started successfully.')
insert tblEvents (vcHostname, vcIpAddress, vcAgent, vcName, vcDescription, dtCreate, dtTerminate, iDuration, vcUser, vcOtherPropA, vcOtherPropB, vcOtherPropC, vcOtherPropD, vcOtherPropE, vcOtherPropF)
	values ('MYDEVA', '4.33.181.83', 'wmi', 'lgcGpecSvcEvent', 'svcEvent', '2000-06-09 04:27:00.000', '', '', '', 'OWSTimer', 'Office Server Extensions Notification Service', '-1', 'Running', 'Manual', 'null')
*/

/*
-- insert some sample data into tblUrls
insert tblUrls (vcLabel, vcUrl)
	values ('Display xml select query of tblEvents using sql', 'http://myrdms/dbGnlPpsEvntCsmr?sql=select+*+from+tblEvents+for+xml+auto&root=root')
insert tblUrls (vcLabel, vcUrl)
	values ('Display xml select query of tblEvents using template', 'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>select+*+from+tblEvents+order+by+idEvent+for+xml+auto</sql:query></root>')
insert tblUrls (vcLabel, vcUrl)
	values ('Display xml select query of tblEvents using xpath template', 'http://myRdms/dbGnlPpsEvntCsmr/template/tmplUser.xml?User=administrator@mydistdom')
insert tblUrls (vcLabel, vcUrl)
	values ('Delete all records from tblEvents', 'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>delete+from+tblEvents</sql:query></root>')
insert tblUrls (vcLabel, vcUrl)
	values ('Refresh this simple web page report, press back and refresh when done', 'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>execute+sp_runwebtask+@procname=N''sp_tblEventsWebRpt'',+@outputfile=N''c:\inetpub\wwwroot\reports\tblEvents.htm''</sql:query></root>')
insert tblUrls (vcLabel, vcUrl)
	values ('Delete this simple web page report', 'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>execute+sp_dropwebtask+@procname=N''sp_tblEventsWebRpt'',+@outputfile=N''c:\inetpub\wwwroot\reports\tblEvents.htm''</sql:query></root>')
insert tblUrls (vcLabel, vcUrl)
	values ('Recreate this simple web page report', 'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>execute+sp_makewebtask+@procname=N''sp_tblEventsWebRpt'',+@outputfile=N''c:\inetpub\wwwroot\reports\tblEvents.htm'',+@query=N''select+[idEvent],+[vcHostname],+[vcIpAddress],+[vcAgent],+[vcName],+[vcDescription],+[dtCreate],+[dtTerminate],+[iDuration],+[vcUser],+[vcOtherPropA],+[vcOtherPropB],+[vcOtherPropC],+[vcOtherPropD],+[vcOtherPropE],+[vcOtherPropF]+from+[tblEvents]+order+by+[idEvent]'',+@fixedfont=1,+@HTMLheader=3,+@webpagetitle=N''Microsoft SQL Server Web Assistant'',+@resultstitle=N''Query Results'',+@table_urls=1,+@url_query=N''select+[vcUrl],+[vcLabel]+from+tblUrls'',+@dbname=N''dbGnlPpsEvntCsmr'',+@whentype=10,+@rowcnt=100,+@nrowsperpage=10,+@datachg=N''table=tblEvents+column=idEvent,vcHostname,vcIpAddress,vcAgent,vcName,vcDescription,dtCreate,dtTerminate,iDuration,vcUser,vcOtherPropA,vcOtherPropB,vcOtherPropC,vcOtherPropD,vcOtherPropE,vcOtherPropF'',+@codepage=65001,+@charset=N''utf-8''</sql:query></root>')
insert tblUrls (vcLabel, vcUrl)
	values ('Display latest updates relating to SQL Server support for XML', 'http://msdn.microsoft.com/xml/default.asp')
*/

/*
-- now generate a simple web page report
-- note - all the commented out entries are examples of alternative web page report creation statements that could be
-- used.  For debugging and demonstration purposes the uncommented entry creates a web page report that is automatically
-- updated whenever the underlying data changes and populates the web page report with a list of url shortcuts extracted
-- from the list of Lable/Url value pairs found in tblUrls that was created and populated in earlier steps
use master
-- go

-- create folders off of default web server wwwroot where virtual directory will be enabled and report files will be
-- placed, if the report folder does not exist or is not accessible by sql2k when sp_makewebtask is run then an error
-- will occurr
execute xp_cmdshell 'if not exist "%systemdrive%\inetpub\wwwroot\dbGnlPpsEvntCsmr" mkdir "%systemdrive%\inetpub\wwwroot\dbGnlPpsEvntCsmr"'
-- go
execute xp_cmdshell 'if not exist "%systemdrive%\inetpub\wwwroot\reports" mkdir %systemdrive%\inetpub\wwwroot\reports"'
-- go
-- if you want to ensure old report file is deleted first before we create new one
-- execute xp_cmdshell 'if exist "%systemdrive%\inetpub\wwwroot\reports\dbGnlPpsEvntCsmr1.htm" net.exe stop w3svc & net.exe stop iisadmin & del "%systemdrive%\inetpub\wwwroot\reports\dbGnlPpsEvntCsmr1.htm" & net.exe start w3svc"'
-- go
-- if you just want to ensure web service is running
execute xp_cmdshell 'net.exe start w3svc'
-- go

use dbGnlPpsEvntCsmr
-- go
*/

/*
-- drop sp_tblEventsWebRpt
if exists (select * from sysobjects where id = object_id(N'[dbo].[sp_tblEventsWebRpt]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
-- drop procedure [dbo].[sp_tblEventsWebRpt]
execute sp_dropwebtask @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\reports\tblEvents.htm'
-- go

-- wait a few seconds for sp_dropwebtask to complete before running sp_makewebtask or errors will occur
-- note - doesn't seem to help
-- waitfor delay '000:00:10'

-- @query = select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]
-- @reftext/@url = Display xml select query using template, http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>select+*+from+tblEvents+order+by+idEvent+for+xml+auto</sql:query></root>
-- OR @table_urls=1, @url_query=N'select [vcUrl], [vcLabel] from tblUrls', see early steps in this script for creation and sample data generation steps
--   note 1 - use single quotes only to wrap url string values in and escape with an additional quote otherwise href on resulting page will be corrupted
--   note 2 - documentation implies that url_query selecct should return label first and url second when in fact it is the other way around
-- @reftext = Display xml select query using template
-- @rowcnt=100, @nrowsperpage=10

-- @whentype=8 = <updates at regular intervals, requires addition of @targetdate, @targettime, @numunits and @unittype properties, useful for production>
-- @targetdate=yyyymmdd, @targettime=hhmmss, @numunits=1, @unittype=4, where unittype=4 = <numunits in minutes, therefore pages should update every minute> 
-- note - for regular interval updates to work it requires that the sqlServerAgent be running
-- single url
-- execute sp_makewebtask  @procname=N'sp_tblEventsWebRpt', @outputfile = N'c:\inetpub\wwwroot\reports\tblEvents.htm', @query=N'select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]', @fixedfont=1, @HTMLheader=3, @webpagetitle=N'Microsoft SQL Server Web Assistant', @resultstitle=N'Query Results', @URL=N'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>select+*+from+tblEvents+order+by+idEvent+for+xml+auto</sql:query></root>', @reftext=N'Display xml select query using template', @dbname=N'dbGnlPpsEvntCsmr', @whentype=8, @targetdate=20000608, @targettime=063000, @numunits=1, @unittype=4, @rowcnt=100, @nrowsperpage=10, @codepage=65001, @charset=N'utf-8'
-- table derived url list
-- execute sp_makewebtask  @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\reports\tblEvents.htm', @query=N'select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]', @fixedfont=1, @HTMLheader=3, @webpagetitle=N'Microsoft SQL Server Web Assistant', @resultstitle=N'Query Results', @table_urls=1, @url_query=N'select [vcUrl], [vcLabel] from tblUrls', @dbname=N'dbGnlPpsEvntCsmr', @whentype=8, @targetdate=20000608, @targettime=063000, @numunits=1, @unittype=4, @rowcnt=100, @nrowsperpage=10, @codepage=65001, @charset=N'utf-8'

-- @whentype=9 <updates on demand>
-- single url
-- execute sp_makewebtask  @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\reports\tblEvents.htm', @query=N'select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]', @fixedfont=1, @HTMLheader=3, @webpagetitle=N'Microsoft SQL Server Web Assistant', @resultstitle=N'Query Results', @URL=N'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>select+*+from+tblEvents+order+by+idEvent+for+xml+auto</sql:query></root>', @reftext=N'Display xml select query using template', @dbname=N'dbGnlPpsEvntCsmr', @whentype=9, @rowcnt=100, @nrowsperpage=10, @codepage=65001, @charset=N'utf-8'
-- table derived url list
-- execute sp_makewebtask  @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\reports\tblEvents.htm', @query=N'select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]', @fixedfont=1, @HTMLheader=3, @webpagetitle=N'Microsoft SQL Server Web Assistant', @resultstitle=N'Query Results', @table_urls=1, @url_query=N'select [vcUrl], [vcLabel] from tblUrls', @dbname=N'dbGnlPpsEvntCsmr', @whentype=9, @rowcnt=100, @nrowsperpage=10, @codepage=65001, @charset=N'utf-8'

-- @whentype=10 <updates when sql data changes, requires addition of @datachg property, useful when debugging>
-- @datachg=N'table=tblEvents column=idEvent,vcHostname,vcIpAddress,vcAgent,vcName,vcDescription,dtCreate,dtTerminate,iDuration,vcUser,vcOtherPropA,vcOtherPropB,vcOtherPropC,vcOtherPropD,vcOtherPropE,vcOtherPropF'
-- single url
-- execute sp_makewebtask @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\reports\tblEvents.htm', @query=N'select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]', @fixedfont=1, @HTMLheader=3, @webpagetitle=N'Microsoft SQL Server Web Assistant', @resultstitle=N'Query Results', @URL=N'http://myRdms/dbGnlPpsEvntCsmr?template=<root+xmlns:sql=''urn:schemas-microsoft-com:xml-sql''><sql:query>select+*+from+tblEvntLog+order+by+iEvntId+for+xml+auto</sql:query></root>', @reftext=N'Display Xml Select Query Results', @dbname=N'dbGnlPpsEvntCsmr', @whentype=10, @rowcnt=100, @nrowsperpage=10, @datachg=N'table=tblEvents column=idEvent,vcHostname,vcIpAddress,vcAgent,vcName,vcDescription,dtCreate,dtTerminate,iDuration,vcUser,vcOtherPropA,vcOtherPropB,vcOtherPropC,vcOtherPropD,vcOtherPropE,vcOtherPropF', @codepage=65001, @charset=N'utf-8'
-- table derived url list
execute sp_makewebtask @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\reports\tblEvents.htm', @query=N'select [idEvent], [vcHostname], [vcIpAddress], [vcAgent], [vcName], [vcDescription], [dtCreate], [dtTerminate], [iDuration], [vcUser], [vcOtherPropA], [vcOtherPropB], [vcOtherPropC], [vcOtherPropD], [vcOtherPropE], [vcOtherPropF] from [tblEvents] order by [idEvent]', @fixedfont=1, @HTMLheader=3, @webpagetitle=N'Microsoft SQL Server Web Assistant', @resultstitle=N'Query Results', @table_urls=1, @url_query=N'select [vcUrl], [vcLabel] from tblUrls', @dbname=N'dbGnlPpsEvntCsmr', @whentype=10, @rowcnt=100, @nrowsperpage=10, @datachg=N'table=tblEvents column=idEvent,vcHostname,vcIpAddress,vcAgent,vcName,vcDescription,dtCreate,dtTerminate,iDuration,vcUser,vcOtherPropA,vcOtherPropB,vcOtherPropC,vcOtherPropD,vcOtherPropE,vcOtherPropF', @codepage=65001, @charset=N'utf-8'

-- to refresh web report now
-- execute sp_runwebtask @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\myRdmsReports\tblEvents.htm'

-- to delete web report now
-- execute sp_dropwebtask @procname=N'sp_tblEventsWebRpt', @outputfile=N'c:\inetpub\wwwroot\myRdmsReports\tblEvents.htm'
-- go
*/