<?xml version="1.0"?>

<!-- if using default setup ie5 / msxml.dll or msxml2.dll w/o xslt 1.0 support -->
<!-- xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl" -->

<!-- if using sep2k msft xml parser release, msxml3.dll w/ xslt 1.0 support -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<!-- note 1 - sql2k october 2000 web release does not support the full suite of xpath and xsl version 1.0 functionality
     see start / programs / microsoftSqlServer / booksOnly / contents / xmlAndInternetSupport / usingXpathQueries
     and guidelinesForUsingXpathQueries and http://msdn.microsoft.com/xml/default.asp for details on what is and 
     is not currently supported, some of the elements/statements shown below have been commented out due to these
     version compatibility issues -->
     
<!-- note 2 - client side script sections will not ignore xml reserved characters even when section is
     enclosed in a <![CDATA[...]]> section unless you use the xslt 1.0 namespace value in your stylesheet
     element above -->

<!-- optional setting if using xslt 1.0 support -->
<!-- xsl:output method="html"/ -->

<xsl:template match="/">
	<html>
	
	<script language="javascript">
	<![CDATA[
	var S_OK = 1, S_FALSE = 0, E_FAIL = 2147500037, DEBUG = 0;  // 0 == release | 1 == debug

	// define client page processing event handler functions
	window.document.onreadystatechange = document_onreadystatechange;
	window.onload = window_onload;
	window.document.onstop = document_onstop;
	window.onunload = window_onunload;

	if (-1 == DEBUG) debugger;
	// optionally setup globals for commonly referenced objects to improve access efficiency
	//	_sProtocol = window.location.protocol, _sHostname = window.location.hostname,
	//	_sPort = window.location.port, _sUrl = window.document.URL, oDoc = window.document,
	//	oXmlDoc = window.document.XMLDocument, oXslDoc = window.document.XSLDocument
	var _sHostname = window.location.hostname, _sUrl = window.document.URL;

	function document_onreadystatechange() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
			switch (window.document.readyState) {
				case "uninitialized":
					// do something
				case "loading":
					// do something
				case "interactive":
					// do something
				case "complete":
					// do something
				default:
					// do something
			}
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}

	function window_onload() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}

	function document_onstop() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}

	function window_onunload() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}		

	function GetUrlPiece(sPiece) {
		if (-1 == DEBUG) debugger;
		var hr = S_OK, sValue = "";
		try {
			var re = /(\w+):\/\/([^/:]+)(:\d*)?([^# ]*)/;
			var arr = re.exec(_sUrl);
			if ("protocol" == sPiece) sValue = RegExp.$1
			if ("host" == sPiece) sValue = RegExp.$2
			if ("port" == sPiece) sValue = RegExp.$3
			if ("relativeUrl" == sPiece) sValue = RegExp.$4
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
	
	function GetEnvVar(sEnvVar) {
		var hr = S_OK, sValue = "";
		try {
			if (-1 == DEBUG) debugger;
			var oInstaller = new ActiveXObject("WindowsInstaller.Installer");
			sValue = oInstaller.Environment(sEnvVar);
		}			
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
	
	function GetParentUrl(sUrl) {
		var hr = S_OK, sValue;
		try {
			if (-1 == DEBUG) debugger;
			var ir = sUrl.lastIndexOf("/");
			if (0 < ir)
				sValue= sUrl.substr(0, ir);
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
	  		alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
	
		
	function GetParentDocUrl() {
		var hr = S_OK, sValue = "";
		if (-1 == DEBUG) debugger;
		try {
			var iStart = _sUrl.lastIndexOf("/"), iEnd = _sUrl.lastIndexOf(".");
			if (0 < iEnd)
				sValue = _sUrl.substr((iStart + 1), (iEnd - iStart - 1));
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
			
	function GetFileName(sDlgTitle, sDefaultPath, sDefaultFileName) {
		if (-1 == DEBUG) debugger;
		var hr = S_OK, sValue = "";
		try {
			// populate the save dialog title, default path and filename
			var sDlgTitle = "Select CSV Export File";
			oComDlg.DialogTitle = sDlgTitle;
			if ("" != sDefaultPath)
				oComDlg.InitDir = sDefaultPath;
			if ("" != sDefaultFileName)
				oComDlg.FileName = sDefaultFileName;
			
			oComDlg.DefaultExt = ".csv";
			// oComDlg.FilterIndex = 1;  // not sure what numbers to use
			
			// now display the open dialog to get file name from user	
			oComDlg.ShowSave();
		
			// if no file name provided loop until one is returned
			while ("" == oComDlg.FileName)
				oComDlg.ShowSave();
				
			sValue = oComDlg.FileName;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description + " - please ensure that " +
				  "your browser can connect to and install " +
				  "http://activex.microsoft.com/controls/vb6/comdlg32.cab " +
				  "before trying this selection again.");
		}	
		if (-1 == DEBUG) debugger;
		return sValue;
	}			
		
	function CsvExport() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
			var sDefaultPath = "";
			// OR optionally preset to a user environment variable path
			// var sDefaultPath = GetEnvVar("userprofile");
			// if ("" == sDefaultPath) throw new Error(hr, "GetEnvVar call failed");
			
			var sDefaultFileName = GetParentDocUrl() + ".csv";
				
			var sFileName = GetFileName("Select CSV Export File", sDefaultPath, sDefaultFileName);
			if ("" == sFileName) throw new Error(hr, "GetFileName call failed");
			
			var oFso = new ActiveXObject("Scripting.FileSystemObject");
			var ForWriting = 2, TristateUseDefault = -2;
			var oTxtStrm = oFso.OpenTextFile(sFileName, ForWriting, true, TristateUseDefault);

			/*  note - skipping load  xml document step since we are working against the
				currently loaded xml document and can therefore save the possible return
				visit to the server by just grabbing the local xml document
			var oXmlDoc = new ActiveXObject("Microsoft.XMLDOM")
			// or ??? var oXmlDoc = new ActiveXObject("Msxml2.DOMDocument");
			oXmlDoc.async = false;
			var br = oXmlDoc.load(sXmlUrl);
			if (br) { hr = S_FALSE; throw hr; }
			*/
			var oXmlDoc = window.document.XMLDocument;	
			var oRootNode = oXmlDoc.documentElement;
			
			if (-1 == DEBUG) debugger;
			// var otblEventsNodeList = oRootNode.selectNodes("tblEvents");
			var otblEventsNodeList = oRootNode.getElementsByTagName("tblEvents");
			for (var iElement = 0; iElement < otblEventsNodeList.length; iElement++) {
			    var otblEventsNode = otblEventsNodeList.item(iElement);
			    var otblEventsNamedNodeMap = otblEventsNode.attributes;
			    // var otblEventsDurationNode = otblEventsNamedNodeMap.getNamedItem("Duration");
			    var sCsvHeader = "", sCsvElement = "";
			    for (var iAttribute = 0; iAttribute < otblEventsNamedNodeMap.length; iAttribute++) {
					if (-1 == DEBUG) debugger;
					if (0 == iElement) {
						// todo: fill in empty column values until wmi consumer is updated to write defaults for create records
						// prcCreate record
						if (11 == otblEventsNamedNodeMap.length && 7 == iAttribute) sCsvHeader += "dtTerminate, iDuration, ";
						// svcEvent record
						if (12 == otblEventsNamedNodeMap.length && 7 == iAttribute) sCsvHeader += "dtTerminate, iDuration, vcUser, ";
						// logEvent record
						if (13 == otblEventsNamedNodeMap.length && 7 == iAttribute &&
							"vcOtherPropA" == otblEventsNamedNodeMap.item(iAttribute).nodeName) sCsvHeader += "dtTerminate, iDuration, vcUser, ";
						sCsvHeader += otblEventsNamedNodeMap.item(iAttribute).nodeName;
						// prcCreate record
						if (11 == otblEventsNamedNodeMap.length && 10 == iAttribute) sCsvHeader += ", vcOtherPropD, vcOtherPropE, vcOtherPropF";
						// svcEvent record
						if (12 == otblEventsNamedNodeMap.length && 11 == iAttribute) sCsvHeader += ", vcOtherPropF";
						// prcTerminate record
						if (13 == otblEventsNamedNodeMap.length && 12 == iAttribute &&
							"vcOtherPropC" == otblEventsNamedNodeMap.item(iAttribute).nodeName) sCsvHeader += ", vcOtherPropD, vcOtherPropE, vcOtherPropF";
					}
					// todo: fill in empty column values until wmi consumer is updated to write defaults for create records
					// prcCreate record
					if (11 == otblEventsNamedNodeMap.length && 7 == iAttribute) sCsvElement += "0000-00-00T00:00:00.000, 0, ";
					// svcEvent record
					if (12 == otblEventsNamedNodeMap.length && 7 == iAttribute) sCsvElement += "0000-00-00T00:00:00.000, 0, (null), ";
					// logEvent record
					if (13 == otblEventsNamedNodeMap.length && 7 == iAttribute &&
						"vcOtherPropA" == otblEventsNamedNodeMap.item(iAttribute).nodeName) sCsvElement += "0000-00-00T00:00:00.000, 0, (null), ";
			        sCsvElement += otblEventsNamedNodeMap.item(iAttribute).text;
			    	// prcCreate record
					if (11 == otblEventsNamedNodeMap.length && 10 == iAttribute) sCsvElement += ", (null), (null), (null)";
					// svcEvent record
					if (12 == otblEventsNamedNodeMap.length && 11 == iAttribute) sCsvElement += ", (null)";
					// prcTerminate record
					if (13 == otblEventsNamedNodeMap.length && 12 == iAttribute &&
						"vcOtherPropC" == otblEventsNamedNodeMap.item(iAttribute).nodeName) sCsvElement += ", (null), (null), (null)";
					if (iAttribute < (otblEventsNamedNodeMap.length - 1)) {
						if (0 == iElement) sCsvHeader += ", ";
			            sCsvElement += ", ";
					}
				}
				if (0 == iElement) oTxtStrm.WriteLine(sCsvHeader);
				oTxtStrm.WriteLine(sCsvElement);
			}
			alert("Export Report to comma-separated-value file " + sFileName + " completed successfully.  " +
				  "Use Microsoft Excel or any other csv file editor to open for review.");
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			if (-2146827859 == oError.number) {  
				// -2146827859/0x800A01AD = "Automation server can't create object"
				// todo - figure out a to resolve if necessary browser setting is enabled so you can throw up dialog
				// explaining situation and asking user if they want you to update the setting for them just for the
				// duration of this routine.
				alert("This selection requires that your browser setting found under - tools / internetOptions / " +
					  "security / customLevel / initAndScrptAxcNotMrkdAsSafe be set to \"enable\" OR \"prompt\".  " +
					  "Please adjust this setting in your browser and then initiate this selection again.");
			}
			if (-2146827859 != oError.number)
				alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		// close the file before exiting routine
		if (oTxtStrm) oTxtStrm.Close();
		return hr;
	}		

	function SetViewXsl(sViewSuffix) {
		// produce a standard or fit to landscape printout view by applying a xsl stylesheet
		var hr = S_OK, sValue;
		try {
			if (-1 == DEBUG) debugger;
			//  derived from xmlsdk30.chm / contents / xsltDevelopersGuide / 
			//  usingTheXsltProcessor / transformingTheContentsOfXmlDataIslandsUsingXslt
			//  and xmlsdk30.chm / contents / xsltDevelopersGuide / 
			//	browsingXmlDocumentsInInternetExplorer5 / browsingXmlusingXslStylesheets
				
			// get the xml document, xml url and xsl url
			var sXmlUrl = window.document.URL,
				sXslUrl = GetParentDocUrl(sXmlUrl) + sViewSuffix;
			// note - if running from server can use Server.MapPath("<filename>") to load xml
			// and xsl files by going straight to disk versus over http
						  
			/*  note - skipping load  xml document step since we are working against the
				currently loaded xml document and can therefore save the possible return
				visit to the server by just grabbing the local xml document
			var oXmlDoc = new ActiveXObject("Microsoft.XMLDOM")
			oXmlDoc.async = false;
			var br = oXmlDoc.load(sXmlUrl);
			if (br) { hr = S_FALSE; throw hr; }
			*/
			var oXmlDoc = window.document.XMLDocument;
				
			// apply the new printer friendly xslt view
			var oXslView = new ActiveXObject("Microsoft.XMLDOM");
			oXslView.async = false;
			oXslView.load(sXslUrl);

			// transform the xml document with new xsl view
			var sHtmlView = oXmlDoc.transformNode(oXslView);
				
			// update dhtml document object html contents
			if (-1 == DEBUG) debugger;
			window.document.body.innerHTML = sHtmlView;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}
		
	function SetViewDhtml() {
		// produce a standard or fit to landscape printout view by applying a dhtml style settings
		var hr = S_OK, sValue;
		try {
			if (-1 == DEBUG) debugger;
			// set table font size
			var sFontSize = window.tblMain.style.fontSize;
			if ("" == sFontSize) {
			// if ("Printer Friendly View" == window.btnView.value)
				window.tblMain.style.fontSize = "10";  // "" (i.e. default value) | 8px | x-small | ...
				window.btnView.value = "Standard View";
			}
			else {
				window.tblMain.style.fontSize = "";  // "" (i.e. default value) | 8px | x-small | ...
				window.btnView.value = "Printer Friendly View";
			}
				
			/*				
			// set standard view | printer friendly view button text and onclick settings
			window.btnView.value = "Standard View";
			window.btnView.onclick = "MakeStdViaDhtml()";
			// note - if above onclick setting continues to fail to take and/or to be more efficient
			// alternately just have one routine here that simply checks the value text string
			// for the button to decide which way we are changing the document
				
			// request refresh of all affected dhtml, didn't seem to effect onclick setting changes
			window.document.recalc(true);  // or no flag to optimize
			*/
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}
	]]>
	</script>	

	<head>
		<title>Application Usage Tracking Service</title>
		<!-- link rel="stylesheet" type="text/css" href="default.css"></link -->
	</head>
	
	<body id="oBody">
		<h1>Application Usage Tracking Service</h1>

		<p>
			<input id="btnClose" type="button" value="Close Report" onclick="window.close()"></input>
			. .
			<input id="btnRefresh" type="button" value="Refresh Report" onclick="window.navigate(window.document.URL)"></input>
			. .
			<input id="btnCsvExport" type="button" value="Export Report" onclick="CsvExport()"></input>
			<!-- br></br><br></br>
			note - export report requires tools / internetOptions / security / customLevel / 
			initializeAndScriptActiveXcontrolsNotMarkedAsSafe = enable OR prompt -->
			. .
			<!-- document view changes using xsl -->
			<input id="btnView" type="button" value="Printer Friendly View" onclick="SetViewXsl('Pf.xsl')"></input>
			<!-- input id="btnView" type="button" value="Standard View" onclick="SetViewXsl('.xsl')"></input -->
			<!-- document view changs using dhtml -->
			<!-- input id="btnView" type="button" value="Printer Friendly View" onclick="SetViewDhtml()" style="font:"></input -->
		</p>
	
		<!-- table border="thin solid blue collapse" -->
		<table id="tblMain" border="1" cellPadding="10" cellSpacing="0" style="font:''">
		<!-- style="font:''" | style="font:10" | style="font:10px" | style="font:medium" | .script.fontSize -->
			<tr align="center">
				<th>idEvent</th><th>vcHostname</th><th>vcIpAddress</th><th>vcAgent</th>
				<th>vcName</th><th>vcDescription</th><th>dtCreate</th><th>dtTerminate</th>
				<th>iDuration</th><th>vcUser</th><th>vcOtherPropA</th><th>vcOtherPropB</th>
				<th>vcOtherPropC</th><th>vcOtherPropD</th><th>vcOtherPropE</th><th>vcOtherPropF</th>
			</tr>
			<!-- xsl:for-each select="//tblEvents" -->  
			<!-- xsl:for-each select="root/tblEvents" -->
			<xsl:for-each select="/root/tblEvents">
			<!-- note - all of the above node selection axis work, starting from least explicit to most explicit -->
				<tr align="left">			 			
					<td><xsl:value-of select="@idEvent"/></td>
					<td><xsl:value-of select="@vcHostname"/></td>
					<td><xsl:value-of select="@vcIpAddress"/></td>
					<td><xsl:value-of select="@vcAgent"/></td>
					<td><xsl:value-of select="@vcName"/></td>
					<td><xsl:value-of select="@vcDescription"/></td>
					<td><xsl:value-of select="@dtCreate"/></td>
					<!-- td><xsl:value-of select="@dtTerminate"/></td -->
					<td><xsl:if test="string-length(@dtTerminate)>0"><xsl:value-of select="@dtTerminate"/></xsl:if>
						<xsl:if test="string-length(@dtTerminate)=0">0000-00-00T00:00:00.000</xsl:if></td>
					<!-- td><xsl:value-of select="@iDuration"/></td -->
					<td><xsl:if test="string-length(@iDuration)>0"><xsl:value-of select="@iDuration"/></xsl:if>
						<xsl:if test="string-length(@iDuration)=0">0</xsl:if></td>
					<!-- td><xsl:value-of select="@vcUser"/></td -->
					<td><xsl:if test="string-length(@vcUser)>0"><xsl:value-of select="@vcUser"/></xsl:if>
						<xsl:if test="string-length(@vcUser)=0">(null)</xsl:if></td>
					<td><xsl:value-of select="@vcOtherPropA"/></td>
					<td><xsl:value-of select="@vcOtherPropB"/></td>
					<td><xsl:value-of select="@vcOtherPropC"/></td>
					<!-- td><xsl:value-of select="@vcOtherPropD"/></td -->
					<td><xsl:if test="string-length(@vcOtherPropD)>0"><xsl:value-of select="@vcOtherPropD"/></xsl:if>
						<xsl:if test="string-length(@vcOtherPropD)=0">(null)</xsl:if></td>
					<!-- td><xsl:value-of select="@vcOtherPropE"/></td -->
					<td><xsl:if test="string-length(@vcOtherPropE)>0"><xsl:value-of select="@vcOtherPropE"/></xsl:if>
						<xsl:if test="string-length(@vcOtherPropE)=0">(null)</xsl:if></td>
					<!-- td><xsl:value-of select="@vcOtherPropF"/></td -->
					<td><xsl:if test="string-length(@vcOtherPropF)>0"><xsl:value-of select="@vcOtherPropF"/></xsl:if>
						<xsl:if test="string-length(@vcOtherPropF)=0">(null)</xsl:if></td>				
				</tr>
			</xsl:for-each>
		</table>

		<br/>

		<!-- note - this next statement drives processing of any other template definitions found later in document -->
		<xsl:apply-templates/>
		
		<!-- License.Manager.1 -->
		<object id="oLicMgr" width="0" height="0"
			classid="clsid:5220CB21-C88D-11cf-B347-00AA00A28331">
			<param name="LPKPath" value="/reports/comdlg32.lpk"></param>
		</object>
		
		<!-- MSComDlg.CommonDialog.1 -->
		<object id="oComDlg" width="0" height="0"
			classid="clsid:F9043C85-F6F2-101A-A3C9-08002B2F49FB"
			codebase="http://activex.microsoft.com/controls/vb6/comdlg32.cab">
		</object>

	</body>
	</html>
</xsl:template>

</xsl:stylesheet>
