<?xml version="1.0"?>

<!-- if using default setup ie5 / msxml.dll or msxml2.dll w/o xslt 1.0 support -->
<!-- xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl" -->

<!-- if using sep2k msft xml parser release, msxml3.dll w/ xslt 1.0 support -->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">

<!-- note 1 - sql2k october 2000 web release does not support the full suite of xpath and xsl version 1.0 functionality
     see start / programs / microsoftSqlServer / booksOnly / contents / xmlAndInternetSupport / usingXpathQueries
     and guidelinesForUsingXpathQueries and http://msdn.microsoft.com/xml/default.asp for details on what is and 
     is not currently supported, some of the elements/statements shown below have been commented out due to these
     version compatibility issues -->
     
<!-- note 2 - client side script sections will not ignore xml reserved characters even when section is
     enclosed in a <![CDATA[...]]> section unless you use the xslt 1.0 namespace value in your stylesheet
     element above -->

<!-- optional setting if using xslt 1.0 support -->
<!-- xsl:output method="html"/ -->

<xsl:template match="/">
	<html>
	
	<script language="javascript">
	<![CDATA[
	var S_OK = 1, S_FALSE = 0, E_FAIL = 2147500037, DEBUG = 0;  // 0 == release | 1 == debug

	// define client page processing event handler functions
	window.document.onreadystatechange = document_onreadystatechange;
	window.onload = window_onload;
	window.document.onstop = document_onstop;
	window.onunload = window_onunload;

	if (-1 == DEBUG) debugger;
	// optionally setup globals for commonly referenced objects to improve access efficiency
	//	_sProtocol = window.location.protocol, _sHostname = window.location.hostname,
	//	_sPort = window.location.port, _sUrl = window.document.URL, oDoc = window.document,
	//	oXmlDoc = window.document.XMLDocument, oXslDoc = window.document.XSLDocument
	var _sHostname = window.location.hostname, _sUrl = window.document.URL;

	function document_onreadystatechange() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
			switch (window.document.readyState) {
				case "uninitialized":
					// do something
				case "loading":
					// do something
				case "interactive":
					// do something
				case "complete":
					// do something
				default:
					// do something
			}
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}

	function window_onload() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}

	function document_onstop() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}

	function window_onunload() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return hr;
	}		

	function GetUrlPiece(sPiece) {
		if (-1 == DEBUG) debugger;
		var hr = S_OK, sValue = "";
		try {
			var re = /(\w+):\/\/([^/:]+)(:\d*)?([^# ]*)/;
			var arr = re.exec(_sUrl);
			if ("protocol" == sPiece) sValue = RegExp.$1
			if ("host" == sPiece) sValue = RegExp.$2
			if ("port" == sPiece) sValue = RegExp.$3
			if ("relativeUrl" == sPiece) sValue = RegExp.$4
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
	
	function GetEnvVar(sEnvVar) {
		var hr = S_OK, sValue = "";
		try {
			if (-1 == DEBUG) debugger;
			var oInstaller = new ActiveXObject("WindowsInstaller.Installer");
			sValue = oInstaller.Environment(sEnvVar);
		}			
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}

	function GetParentUrl(sUrl) {
		var hr = S_OK, sValue;
		try {
			if (-1 == DEBUG) debugger;
			var ir = sUrl.lastIndexOf("/");
			if (0 < ir)
				sValue= sUrl.substr(0, ir);
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
	  		alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
			
	function GetParentDocUrl() {
		var hr = S_OK, sValue = "";
		if (-1 == DEBUG) debugger;
		try {
			var iStart = _sUrl.lastIndexOf("/"), iEnd = _sUrl.lastIndexOf(".");
			if (0 < iEnd)
				sValue = _sUrl.substr((iStart + 1), (iEnd - iStart - 1));
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		return sValue;
	}
			
	function GetFileName(sDlgTitle, sDefaultPath, sDefaultFileName) {
		if (-1 == DEBUG) debugger;
		var hr = S_OK, sValue = "";
		try {
			// populate the save dialog title, default path and filename
			var sDlgTitle = "Select CSV Export File";
			oComDlg.DialogTitle = sDlgTitle;
			if ("" != sDefaultPath)
				oComDlg.InitDir = sDefaultPath;
			if ("" != sDefaultFileName)
				oComDlg.FileName = sDefaultFileName;
			
			oComDlg.DefaultExt = ".csv";
			// oComDlg.FilterIndex = 1;  // not sure what numbers to use
			
			// now display the open dialog to get file name from user	
			oComDlg.ShowSave();
		
			// if no file name provided loop until one is returned
			while ("" == oComDlg.FileName)
				oComDlg.ShowSave();
				
			sValue = oComDlg.FileName;
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			alert(oError.number + "\n" + oError.description + " - please ensure that " +
				  "your browser can connect to and install " +
				  "http://activex.microsoft.com/controls/vb6/comdlg32.cab " +
				  "before trying this selection again.");
		}	
		if (-1 == DEBUG) debugger;
		return sValue;
	}			
		
	function CsvExport() {
		var hr = S_OK;
		try {
			if (-1 == DEBUG) debugger;
			var sDefaultPath = "";
			// OR optionally preset to a user environment variable path
			// var sDefaultPath = GetEnvVar("userprofile");
			// if ("" == sDefaultPath) throw new Error(hr, "GetEnvVar call failed");
			
			var sDefaultFileName = GetParentDocUrl() + ".csv";
				
			var sFileName = GetFileName("Select CSV Export File", sDefaultPath, sDefaultFileName);
			if ("" == sFileName) throw new Error(hr, "GetFileName call failed");
			
			var oFso = new ActiveXObject("Scripting.FileSystemObject");
			var ForWriting = 2, TristateUseDefault = -2;
			var oTxtStrm = oFso.OpenTextFile(sFileName, ForWriting, true, TristateUseDefault);

			/*  note - skipping load  xml document step since we are working against the
				currently loaded xml document and can therefore save the possible return
				visit to the server by just grabbing the local xml document
			var oXmlDoc = new ActiveXObject("Microsoft.XMLDOM")
			// or ??? var oXmlDoc = new ActiveXObject("Msxml2.DOMDocument");
			oXmlDoc.async = false;
			var br = oXmlDoc.load(sXmlUrl);
			if (br) { hr = S_FALSE; throw hr; }
			*/
			var oXmlDoc = window.document.XMLDocument;	
			var oRootNode = oXmlDoc.documentElement;
			
			if (-1 == DEBUG) debugger;
			// var otblEventsNodeList = oRootNode.selectNodes("tblEvents");
			var otblEventsNodeList = oRootNode.getElementsByTagName("tblEvents");
			for (var iElement = 0; iElement < otblEventsNodeList.length; iElement++) {
			    var otblEventsNode = otblEventsNodeList.item(iElement);
			    var otblEventsNamedNodeMap = otblEventsNode.attributes;
			    // var otblEventsDurationNode = otblEventsNamedNodeMap.getNamedItem("Duration");
			    var sCsvHeader = "", sCsvElement = "";
			    for (var iAttribute = 0; iAttribute < otblEventsNamedNodeMap.length; iAttribute++) {
					if (-1 == DEBUG) debugger;
					if (0 == iElement) {
						// todo: fill in empty column values until wmi consumer is updated to write defaults for create records
						// if (4 == otblEventsNamedNodeMap.length && 2 == iAttribute) sCsvHeader += "Duration, ";
						// if (4 == otblEventsNamedNodeMap.length && 3 == iAttribute) sCsvHeader += "Terminate, ";
						sCsvHeader += otblEventsNamedNodeMap.item(iAttribute).nodeName;
					}
					// todo: fill in empty column values until wmi consumer is updated to write defaults for create records
					// if (4 == otblEventsNamedNodeMap.length && 2 == iAttribute) sCsvElement += "0, ";
					// if (4 == otblEventsNamedNodeMap.length && 3 == iAttribute) sCsvElement += "0000-00-00T00:00:00.000, ";
			        sCsvElement += otblEventsNamedNodeMap.item(iAttribute).text;
			        if (iAttribute < (otblEventsNamedNodeMap.length - 1)) {
						if (0 == iElement) sCsvHeader += ", ";
			            sCsvElement += ", ";
					}
				}
				if (0 == iElement) oTxtStrm.WriteLine(sCsvHeader);
				oTxtStrm.WriteLine(sCsvElement);
			}
			alert("Export Report to comma-separated-value file " + sFileName + " completed successfully.  " +
				  "Use Microsoft Excel or any other csv file editor to open for review.");
		}
		catch (oError) {
			if (-1 == DEBUG) debugger;
			if (S_OK == hr) hr = E_FAIL;
			if (-2146827859 == oError.number) {  
				// -2146827859/0x800A01AD = "Automation server can't create object"
				// todo - figure out a to resolve if necessary browser setting is enabled so you can throw up dialog
				// explaining situation and asking user if they want you to update the setting for them just for the
				// duration of this routine.
				alert("This selection requires that your browser setting found under - tools / internetOptions / " +
					  "security / customLevel / initAndScrptAxcNotMrkdAsSafe be set to \"enable\" OR \"prompt\".  " +
					  "Please adjust this setting in your browser and then initiate this selection again.");
			}
			if (-2146827859 != oError.number)
				alert(oError.number + "\n" + oError.description);
		}
		if (-1 == DEBUG) debugger;
		// close the file before exiting routine
		if (oTxtStrm) oTxtStrm.Close();
		return hr;
	}
	]]>	
	</script>
	
	<head>
		<title>Application Usage Tracking Service</title>
		<!-- link rel="stylesheet" type="text/css" href="default.css"></link -->
	</head>

	<body>
		<h1>Application Usage Tracking Service</h1>
		
		<p>
			<input id="btnClose" type="button" value="Close Report" onclick="window.close()"></input>
			. .
			<input id="btnRefresh" type="button" value="Refresh Report" onclick="window.navigate(window.document.URL)"></input>
			. .
			<input id="btnCsvExport" type="button" value="Export Report" onclick="CsvExport()"></input>
			<!-- br></br><br></br>
			note - export report requires tools / internetOptions / security / customLevel / 
			initializeAndScriptActiveXcontrolsNotMarkedAsSafe = enable OR prompt -->			
		</p>
		
		<!-- xsl:comment>some comment for each template match [optionally with value-of data, i.e. user = <xsl:value-of select="tblEvents"/>]</xsl:comment -->
		<!-- table border="thin solid blue collapse" -->
		<table border="1" cellPadding="10" cellSpacing="0"> 
			<tr align="center">
				<th>Type</th><th>Source</th><th>EventCode</th><th>Create</th>
				<th>Hostname</th><th>Description</th>
			</tr>
			<!-- xsl:for-each select="//tblEvents" -->  
			<!-- xsl:for-each select="root/tblEvents" -->
			<xsl:for-each select="/root/tblEvents">
			<!-- note - all of the above node selection axis work, starting from least explicit to most explicit -->
				<tr align="left">
					<td><xsl:value-of select="@Type"/></td>
					<td><xsl:value-of select="@Source"/></td>
					<td><xsl:value-of select="@EventCode"/></td>
					<td><xsl:value-of select="@Create"/></td>
					<td><xsl:value-of select="@Hostname"/></td>
					<td><xsl:value-of select="@Description"/></td>
				</tr>
			</xsl:for-each>
		</table>

		<br/>

		<!-- note - this next statement drives processing of any other template definitions found later in document -->
		<xsl:apply-templates/>
		
		<!-- License.Manager.1 -->
		<object id="oLicMgr" width="0" height="0"
			classid="clsid:5220CB21-C88D-11cf-B347-00AA00A28331">
			<param name="LPKPath" value="/reports/comdlg32.lpk"></param>
		</object>
		
		<!-- MSComDlg.CommonDialog.1 -->
		<object id="oComDlg" width="0" height="0"
			classid="clsid:F9043C85-F6F2-101A-A3C9-08002B2F49FB"
			codebase="http://activex.microsoft.com/controls/vb6/comdlg32.cab">
		</object>

	</body>
	</html>
</xsl:template>

</xsl:stylesheet>

