// Wecp.cpp : Implementation of CWecp
#include "stdafx.h"
#include "GnlPpsEvntCsmr.h"
#include "Wecp.h"

/////////////////////////////////////////////////////////////////////////////
// CWecp


STDMETHODIMP CWecp::Initialize(LPWSTR wszUser, LONG lFlags, LPWSTR wszNamespace, LPWSTR wszLocale, IWbemServices *pNamespace, IWbemContext *pCtx, IWbemProviderInitSink *pInitSink)
{
	HRESULT hr = WBEM_NO_ERROR;  // == S_OK
	try {
		// we don't care about most of the incoming parameters in this service.  We also really don't have anything
		// that needs initializing so we will simply signal that we are initialized and return.

		// tell CIMOM that we are up and running, aka initialized
		hr = pInitSink->SetStatus(WBEM_S_INITIALIZED, 0);
		if (FAILED(hr)) throw hr;

		hr = WBEM_S_NO_ERROR;  // == WBEM_NO_ERROR == S_OK
	}

	catch(...) {
		OutputDebugStringEx(hr, _bstr_t(_T("Initialize")));
		if (SUCCEEDED(hr)) throw;  // pass unexpected exceptions on to the outer block
	}
    
	return hr;
}


STDMETHODIMP CWecp::FindConsumer(IWbemClassObject *pLogicalConsumer, IWbemUnboundObjectSink **ppConsumer)
{
	// purpose = create an instance of IWbemUnboundObjectSink and assign it to the ppConsumer parameter
	HRESULT hr = S_OK;
	try {
		// validate parameters
		if (!pLogicalConsumer || !ppConsumer) { hr = E_INVALIDARG; throw hr; }

		IWbemUnboundObjectSinkPtr pWbemUnboundObjectSink;
		// hr = pWbemUnboundObjectSink.CreateInstance(__uuidof(IWbemUnboundObjectSink), NULL);
		hr = pWbemUnboundObjectSink.CreateInstance(CLSID_Wuos, NULL);
		if (FAILED(hr)) throw hr;
		*ppConsumer = pWbemUnboundObjectSink.Detach();
	}

	catch(...) {
		OutputDebugStringEx(hr, _bstr_t(_T("FindConsumer")));
		if (SUCCEEDED(hr)) throw;  // pass unexpected exceptions on to the outer block
	}

	return hr;
}
